DocIdSetIterator (Lucene 3.6.2 API)
Keywords: org.apache.lucene.search.DocIdSetIterator class

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.lucene.search
Class DocIdSetIterator

    java.lang.Object
      org.apache.lucene.search.DocIdSetIterator

Direct Known Subclasses:
  FilteredDocIdSetIterator, OpenBitSetIterator, Scorer

    public abstract class DocIdSetIterator

extends Object

This abstract class defines methods to iterate over a set of non-decreasing doc ids. Note that this class assumes it iterates on doc Ids, and therefore `NO_MORE_DOCS` is set to 2147483647 in order to be used as a sentinel object. Implementations of this class are expected to consider `Integer.MAX_VALUE` as an invalid value.

Field Summary
`static int` | `NO_MORE_DOCS` When returned by `nextDoc()`, `advance(int)` and `docID()` it means there are no more docs in the iterator.

Constructor Summary
`DocIdSetIterator()`

Method Summary
`abstract int` | `advance(int target)` Advances to the first beyond (see NOTE below) the current whose document number is greater than or equal to target.
`abstract int` | `docID()` Returns the following: -1 or `NO_MORE_DOCS` if `nextDoc()` or `advance(int)` were not called yet.
`abstract int` | `nextDoc()` Advances to the next document in the set and returns the doc it is currently on, or `NO_MORE_DOCS` if there are no more docs in the set. NOTE: after the iterator has exhausted you should not call this method, as it may result in unpredicted behavior.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### NO_MORE_DOCS

    public static final int NO_MORE_DOCS

  When returned by `nextDoc()`, `advance(int)` and `docID()` it means there are no more docs in the iterator.

  See Also:
    Constant Field Values

Constructor Detail

### DocIdSetIterator

    public DocIdSetIterator()

Method Detail

### docID

    public abstract int docID()

  Returns the following:
  - -1 or `NO_MORE_DOCS` if `nextDoc()` or `advance(int)` were not called yet.
  - `NO_MORE_DOCS` if the iterator has exhausted.
  - Otherwise it should return the doc ID it is currently on.

  Since:
    2.9

### nextDoc

    public abstract int nextDoc()
                         throws IOException

  Advances to the next document in the set and returns the doc it is currently on, or `NO_MORE_DOCS` if there are no more docs in the set.
  NOTE: after the iterator has exhausted you should not call this method, as it may result in unpredicted behavior.

  Throws:
    `IOException`
  Since:
    2.9

### advance

    public abstract int advance(int target)
                         throws IOException

  Advances to the first beyond (see NOTE below) the current whose document number is greater than or equal to target. Returns the current document number or `NO_MORE_DOCS` if there are no more docs in the set.

  Behaves as if written:

       int advance(int target) {
         int doc;
         while ((doc = nextDoc()) < target) {
         }
         return doc;
       }

  Some implementations are considerably more efficient than that.

  NOTE: when `target ≤ current` implementations may opt not to advance beyond their current `docID()`.

  NOTE: this method may be called with `NO_MORE_DOCS` for efficiency by some Scorers. If your implementation cannot efficiently determine that it should exhaust, it is recommended that you check for that value in each call to this method.

  NOTE: after the iterator has exhausted you should not call this method, as it may result in unpredicted behavior.

  Throws:
    `IOException`
  Since:
    2.9

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD